<template>
  <app-layout title="Dashboard">
    <toast :toast="toast"></toast>
    <template #header>
      <div class="flex justify-between">
        <h2 class="font-semibold text-xl text-gray-800 leading-tight mt-2">Users Index</h2>
        <button
          @click="openModal()"
          class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded"
        >Create New User</button>
      </div>
    </template>

    <div class="py-12">
      <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
        <div class="bg-white overflow-hidden shadow-xl sm:rounded-lg">
          <table class="w-full divide-y divide-gray-200">
            <thead class="bg-gray-50">
              <tr>
                <th
                  scope="col"
                  class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                >Name</th>
                <th
                  scope="col"
                  class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                >Title</th>
                <th
                  scope="col"
                  class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                >Status</th>
                <th
                  scope="col"
                  class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                >Role</th>
                <th scope="col" class="relative px-6 py-3">
                  <span class="sr-only">Edit</span>
                </th>
              </tr>
            </thead>
            <tbody class="bg-white divide-y divide-gray-200">
              <tr v-for="user in users.data" :key="user.id">
                <td class="px-6 py-4 whitespace-nowrap">
                  <div class="flex items-center">
                    <div class="flex-shrink-0 h-10 w-10">
                      <img class="h-10 w-10 rounded-full" :src="user.profile_photo_url" alt />
                    </div>
                    <div class="ml-4">
                      <div class="text-sm font-medium text-gray-900">{{user.name}}</div>
                      <div class="text-sm text-gray-500">{{user.email}}</div>
                    </div>
                  </div>
                </td>
                <td class="px-6 py-4 whitespace-nowrap">
                  <div class="text-sm text-gray-900">Regional Paradigm Technician</div>
                  <div class="text-sm text-gray-500">Optimization</div>
                </td>
                <td class="px-6 py-4 whitespace-nowrap">
                  <span
                    class="px-2 inline-flex text-xs leading-5 font-semibold rounded-full bg-green-100 text-green-800"
                  >{{user.created_at}}</span>
                </td>
                <td class="px-6 py-4 whitespace-nowrap text-sm text-gray-500">Admin</td>
                <td class="px-6 py-4 whitespace-nowrap text-right text-sm font-medium">
                  <button
                    @click="edit(user)"
                    class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded"
                  >Edit</button>

                  <button
                    @click="confirmUserRemoval(user)"
                    class="bg-red-500 hover:bg-red-700 text-white font-bold py-2 px-4 rounded"
                  >Delete</button>
                </td>
              </tr>
              <!-- More people... -->
            </tbody>
          </table>
          <pagination :links="users.links" class="mt-6" />
        </div>
      </div>
    </div>

    <jet-dialog-modal :show="isOpen">
      <template v-slot:title>
        <h1>Edit User</h1>
      </template>

      <template v-slot:content>
        <div class="mt-4">
          <jet-label for="name">Name</jet-label>
          <jet-input id="name" v-model="form.name" type="text" class="mt-1 block w-full"></jet-input>
          <jet-input-error :message="form.errors.name"></jet-input-error>
        </div>

        <div class="mt-4">
          <jet-label for="email">Email</jet-label>
          <jet-input id="email" v-model="form.email" type="email" class="mt-1 block w-full"></jet-input>
          <jet-input-error :message="form.errors.email"></jet-input-error>
        </div>

        <div class="mt-4">
          <jet-label for="password">Password</jet-label>
          <jet-input
            id="password"
            v-model="form.password"
            type="password"
            class="mt-1 block w-full"
          ></jet-input>
          <jet-input-error :message="form.errors.password"></jet-input-error>
        </div>

        <div class="mt-4">
          <jet-label for="password_confirmation">Password confirmation</jet-label>
          <jet-input
            id="password_confirmation"
            v-model="form.password_confirmation"
            type="password"
            class="mt-1 block w-full"
          ></jet-input>
        </div>
      </template>
      <template v-slot:footer>
        <button
          @click="closeModal()"
          type="button"
          class="inline-flex justify-center py-2 px-4 border border-transparent shadow-sm text-sm font-medium rounded-md text-white bg-gray-600 hover:bg-gray-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-gray-500"
        >Cancel</button>

        <button
          class="ml-2 inline-flex justify-center py-2 px-4 border border-transparent shadow-sm text-sm font-medium rounded-md text-white bg-indigo-600 hover:bg-indigo-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500"
          v-show="!editMode"
          @click="save()"
        >Create User</button>

        <button
          class="ml-2 inline-flex justify-center py-2 px-4 border border-transparent shadow-sm text-sm font-medium rounded-md text-white bg-indigo-600 hover:bg-indigo-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500"
          v-show="editMode"
          @click="update(form)"
        >Update User</button>
      </template>
    </jet-dialog-modal>

    <jet-confirmation-modal :show="userBeingRemoved" @close="userBeingRemoved = null">
      <template #title>Remove Team Member</template>

      <template #content>Are you sure to delete user?</template>

      <template #footer>
        <jet-secondary-button @click="userBeingRemoved = null">Cancel</jet-secondary-button>

        <jet-danger-button
          class="ml-2"
          @click="removeUser"
          :class="{ 'opacity-25': removeUserForm.processing }"
          :disabled="removeUserForm.processing"
        >Remove</jet-danger-button>
      </template>
    </jet-confirmation-modal>
  </app-layout>
</template>

<script>
import { Inertia } from "@inertiajs/inertia";
import { defineComponent } from "vue";
import AppLayout from "@/Layouts/AppLayout.vue";
import JetDialogModal from "@/Jetstream/DialogModal";
import JetLabel from "@/Jetstream/Label.vue";
import JetInput from "@/Jetstream/Input.vue";
import JetInputError from "@/Jetstream/InputError.vue";
import JetButton from "@/Jetstream/Button.vue";
import JetConfirmationModal from "@/Jetstream/ConfirmationModal.vue";
import JetSecondaryButton from "@/Jetstream/SecondaryButton.vue";
import JetDangerButton from "@/Jetstream/DangerButton.vue";
import Toast from "@/Shared/Toast.vue";
import Pagination from "@/Shared/Pagination.vue";

export default defineComponent({
  props: {
    users: Object,
    errors: Object,
    toast: Object,
  },
  data() {
    return {
      isOpen: false,
      editMode: false,
      form: Inertia.form({
        name: "",
        email: "",
        password: "",
        password_confirmation: "",
      }),
      removeUserForm: Inertia.form(),
      userBeingRemoved: null,
    };
  },
  components: {
    AppLayout,
    JetDialogModal,
    JetLabel,
    JetInput,
    JetInputError,
    JetButton,
    JetConfirmationModal,
    JetSecondaryButton,
    JetDangerButton,
    Toast,
    Pagination,
  },
  methods: {
    openModal() {
      this.isOpen = true;
    },
    closeModal() {
      this.isOpen = false;
      this.form.reset();
      this.form.clearErrors();
      this.editMode = false;
    },
    save() {
      this.form.post(this.route("admin.user.store"), {
        onSuccess: () => {
          this.closeModal();
        },
      });
    },

    edit(data) {
      this.form = Object.assign({}, this.form, data);
      this.editMode = true;
      this.openModal();
    },

    update() {
      this.form.put(route("admin.user.update", this.form.id), {
        onSuccess: () => {
          this.closeModal();
        },
      });
    },

    confirmUserRemoval(user) {
      this.userBeingRemoved = user.id;
    },

    removeUser() {
      this.removeUserForm.delete(
        route("admin.user.destroy", this.userBeingRemoved),
        {
          errorBag: "removeUser",
          onSuccess: () => (this.userBeingRemoved = null),
        }
      );
    },
  },
});
</script>
